package com.xiaoniu.subsystem.system.service.impl;

import com.xiaoniu.subsystem.menu.service.ISysMenuService;
import com.xiaoniu.subsystem.system.domain.SysUser;
import com.xiaoniu.subsystem.system.service.ISysPermissionService;
import com.xiaoniu.subsystem.system.service.ISysRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashSet;
import java.util.Set;

/**
 * 用户权限处理
 *
 * @author xiaoniu
 */
@Service
public class SysPermissionServiceImpl implements ISysPermissionService {
    @Autowired
    private ISysRoleService roleService;

    @Autowired
    private ISysMenuService menuService;

    /**
     * 获取角色数据权限
     *
     * @return 角色权限信息
     */
    @Override
    public Set<String> getRolePermission(SysUser user) {
        Set<String> roles = new HashSet<String>();
        // 管理员拥有所有权限
        if (isAdmin(user.getUserId())) {
            roles.add("admin");
        } else {
            roles.addAll(roleService.selectRolePermissionByUserId(user.getUserId()));
        }
        return roles;
    }

    /**
     * 获取菜单数据权限
     *
     * @return 菜单权限信息
     */
    @Override
    public Set<String> getMenuPermission(SysUser user) {
        Set<String> perms = new HashSet<String>();
        // 管理员拥有所有权限
        if (isAdmin(user.getUserId())) {
            perms.add("*:*:*");
        } else {
//            List<SysRole> roles = user.getRoles();
//            if (!CollectionUtils.isEmpty(roles)) {
//                // 多角色设置permissions属性，以便数据权限匹配权限
//                for (SysRole role : roles) {
//                    Set<String> rolePerms = menuService.selectMenuPermsByRoleId(role.getRoleId());
//                    role.setPermissions(rolePerms);
//                    perms.addAll(rolePerms);
//                }
//            } else {
            perms.addAll(menuService.selectMenuPermsByUserId(user.getUserId()));
            //}
        }
        return perms;
    }

    public static boolean isAdmin(Long userId) {
        return userId != null && 1L == userId;
    }
}
